searchNodes=[{"doc":"This module is used by a custom websocket, which can then handle connections from a client implementing the GraphQL over WebSocket protocol Options schema - required - The Absinthe schema for the current application (example: MyAppWeb.Schema ) keepalive - optional - Interval in milliseconds to send :ping control frames over the websocket. Defaults to 30_000 (30 seconds). pipeline - optional - A {module, function} tuple defining how to generate an Absinthe pipeline for each incoming message. Defaults to {Absinthe.GraphqlWS.Socket, :absinthe_pipeline} . Example defmodule MyAppWeb.GraphqlSocket do use Absinthe.GraphqlWS.Socket , schema : MyAppWeb.Schema def handle_message ( _msg , socket ) do { :ok , socket } end end","ref":"Absinthe.GraphqlWS.Socket.html","title":"Absinthe.GraphqlWS.Socket","type":"behaviour"},{"doc":"Provides a stub implementation that allows the socket to start. Phoenix.Socket.Transport expects a child spec that starts a process, so we do so with a noop Task.","ref":"Absinthe.GraphqlWS.Socket.html#__child_spec__/3","title":"Absinthe.GraphqlWS.Socket.__child_spec__/3","type":"function"},{"doc":"When a client connects to this websocket, this function is called to initialize the socket.","ref":"Absinthe.GraphqlWS.Socket.html#__connect__/3","title":"Absinthe.GraphqlWS.Socket.__connect__/3","type":"function"},{"doc":"Provides the default absinthe pipeline","ref":"Absinthe.GraphqlWS.Socket.html#absinthe_pipeline/2","title":"Absinthe.GraphqlWS.Socket.absinthe_pipeline/2","type":"function"},{"doc":"Handles messages that are sent to this process through send/2 , which have not been caught by the default implementation. Example def handle_message ( { :thing , thing } , socket ) do { :ok , assign ( socket , :thing , thing ) } end def handle_message ( _msg , socket ) do { :ok , socket } end","ref":"Absinthe.GraphqlWS.Socket.html#c:handle_message/2","title":"Absinthe.GraphqlWS.Socket.handle_message/2","type":"callback"},{"doc":"Opcode atoms for messages handled by handle_control/2 . Used by server-side keepalive messages.","ref":"Absinthe.GraphqlWS.Socket.html#t:control/0","title":"Absinthe.GraphqlWS.Socket.control/0","type":"type"},{"doc":"Opcode atoms for messages returned by handle_in/2 .","ref":"Absinthe.GraphqlWS.Socket.html#t:opcode/0","title":"Absinthe.GraphqlWS.Socket.opcode/0","type":"type"},{"doc":"Valid replies from Absinthe.GraphqlWS.Transport.handle_in/2","ref":"Absinthe.GraphqlWS.Socket.html#t:reply/0","title":"Absinthe.GraphqlWS.Socket.reply/0","type":"type"},{"doc":"Valid replies from handle_message/2","ref":"Absinthe.GraphqlWS.Socket.html#t:response/0","title":"Absinthe.GraphqlWS.Socket.response/0","type":"type"},{"doc":"A socket that holds information necessary for parsing incoming messages as well as outgoing subscription data.","ref":"Absinthe.GraphqlWS.Socket.html#t:t/0","title":"Absinthe.GraphqlWS.Socket.t/0","type":"type"},{"doc":"Handles messages coming into the socket from clients (implemented in handle_in/2 ) as well as messages coming from within Elixir/Absinthe (implemented in handle_info/2 ). If the optional Absinthe.GraphqlWS.Socket.handle_message/2 callback is implemented on the socket, then messages that are not specifically caught by handle_info/2 in this module will be passed through to Absinthe.GraphqlWS.Socket.handle_message/2 .","ref":"Absinthe.GraphqlWS.Transport.html","title":"Absinthe.GraphqlWS.Transport","type":"module"},{"doc":"Generally this will only receive :pong messages in response to our keepalive ping messages. Client-side websocket libraries handle these control frames automatically in order to adhere to the spec, so unless a customer is writing their own low-level websocket it should be handled for them.","ref":"Absinthe.GraphqlWS.Transport.html#handle_control/2","title":"Absinthe.GraphqlWS.Transport.handle_control/2","type":"function"},{"doc":"Receive messages from clients. We expect all incoming messages to be JSON encoded text, so if something else comes in we blow up.","ref":"Absinthe.GraphqlWS.Transport.html#handle_in/2","title":"Absinthe.GraphqlWS.Transport.handle_in/2","type":"function"},{"doc":"Receive messages from inside the house. :keepalive - Regularly send messages with opcode of 0x09 , ie :ping . The graphql-ws library has a strong opinion that it does not want to implement client-side keepalive, so in order to keep the websocket from closing we need to send it messages. subscription:data - After we subscribe to an Absinthe subscription, we may receive messages for the relevant subscription. The graphql-ws will have sent us an id along with the subscription query, so we need to map our internal topic back to that id in order for the client to figure out what to do with our message. :complete - If we get a query or a mutation on the websocket, we're supposed to reply with a Next message followed by a Complete message. We follow through on the latter by putting a message on our process queue. fallthrough - If handle_message/2 is defined on the socket, then uncaught messages will be sent","ref":"Absinthe.GraphqlWS.Transport.html#handle_info/2","title":"Absinthe.GraphqlWS.Transport.handle_info/2","type":"function"},{"doc":"Callbacks for parsed JSON payloads coming in from a client. See: https://github.com/enisdenjo/graphql-ws/blob/master/PROTOCOL.md","ref":"Absinthe.GraphqlWS.Transport.html#handle_message/2","title":"Absinthe.GraphqlWS.Transport.handle_message/2","type":"function"},{"doc":"Subscribe messages in graphql-ws may include a subscription, implying a subscription to a long term stream of data. These messages may also be queries or mutations, so do not require a stream.","ref":"Absinthe.GraphqlWS.Transport.html#handle_subscribe/3","title":"Absinthe.GraphqlWS.Transport.handle_subscribe/3","type":"function"},{"doc":"","ref":"Absinthe.GraphqlWS.Transport.html#pipeline/2","title":"Absinthe.GraphqlWS.Transport.pipeline/2","type":"function"},{"doc":"Process was stopped.","ref":"Absinthe.GraphqlWS.Transport.html#terminate/2","title":"Absinthe.GraphqlWS.Transport.terminate/2","type":"function"},{"doc":"Helper functions that are imported into a module using Absinthe.GraphqlWS.Socket .","ref":"Absinthe.GraphqlWS.Util.html","title":"Absinthe.GraphqlWS.Util","type":"module"},{"doc":"","ref":"Absinthe.GraphqlWS.Util.html#assign/2","title":"Absinthe.GraphqlWS.Util.assign/2","type":"function"},{"doc":"Implementation copied from Phoenix.Socket , but changed to match on a Absinthe.GraphqlWS.Socket struct.","ref":"Absinthe.GraphqlWS.Util.html#assign/3","title":"Absinthe.GraphqlWS.Util.assign/3","type":"function"},{"doc":"Indicates that the requested operation execution has completed. If the server dispatched the Error message relative to the original Subscribe message, no Complete message will be emitted.","ref":"Absinthe.GraphqlWS.Message.Complete.html","title":"Absinthe.GraphqlWS.Message.Complete","type":"module"},{"doc":"","ref":"Absinthe.GraphqlWS.Message.Complete.html#new/2","title":"Absinthe.GraphqlWS.Message.Complete.new/2","type":"function"},{"doc":"Must be sent in response to a ConnectionInit message from the client.","ref":"Absinthe.GraphqlWS.Message.ConnectionAck.html","title":"Absinthe.GraphqlWS.Message.ConnectionAck","type":"module"},{"doc":"","ref":"Absinthe.GraphqlWS.Message.ConnectionAck.html#new/1","title":"Absinthe.GraphqlWS.Message.ConnectionAck.new/1","type":"function"},{"doc":"Operation execution error(s) triggered by the Next message happening before the actual execution, usually due to validation errors.","ref":"Absinthe.GraphqlWS.Message.Error.html","title":"Absinthe.GraphqlWS.Message.Error","type":"module"},{"doc":"","ref":"Absinthe.GraphqlWS.Message.Error.html#new/2","title":"Absinthe.GraphqlWS.Message.Error.new/2","type":"function"},{"doc":"Operation execution result(s) from the source stream created by the binding Subscribe message. After all results have been emitted, the Complete message will follow indicating stream completion.","ref":"Absinthe.GraphqlWS.Message.Next.html","title":"Absinthe.GraphqlWS.Message.Next","type":"module"},{"doc":"","ref":"Absinthe.GraphqlWS.Message.Next.html#new/2","title":"Absinthe.GraphqlWS.Message.Next.new/2","type":"function"},{"doc":"Overview Absinthe provides the absinthe_phoenix library, which allows a Phoenix application to register a new socket to receive GraphQL messages over a Phoenix channel. The downside of this is that clients of this must connect to the websocket with a Phoenix-specific client library. The GraphQL over WebSocket Protocol is an attempt to define a generic transport protocol with few or no dependencies that is simple to implement. This library implements a socket that can be use 'd by a module and added to a Phoenix endpoint.","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"Installation Add absinthe_graphql_ws to deps: def deps do [ { :absinthe , &quot;~&gt; 1.6&quot; } , { :absinthe_graphql_ws , github : &quot;geometerio/absinteh_graphql_ws&quot; } , { :phoenix , &quot;~&gt; 1.5&quot; } # ... ] end","ref":"installation.html","title":"Installation","type":"extras"},{"doc":"In lib/my_app_web/channels , add a new socket: defmodule MyAppWeb.GraphqlWSSocket do use Absinthe.GraphqlWS.Socket , schema : MyAppWeb.Schema end","ref":"installation.html#custom-socket","title":"Installation - Custom socket","type":"extras"},{"doc":"Now mount the socket in your Phoenix.Endpoint: socket &quot;/api/graphql-ws&quot; , MyAppWeb.GraphqlWSSocket , websocket : [ path : &quot;&quot; , subprotocols : [ &quot;graphql-transport-ws&quot; ] ]","ref":"installation.html#phoenix-endpoint","title":"Installation - Phoenix endpoint","type":"extras"},{"doc":"If the socket process will receive custom messages from within the application, then the Absinthe.GraphqlWS.Socket.handle_message/2 optional callback can be defined to handle these: defmodule MyAppWeb.GraphqlWSSocket do use Absinthe.GraphqlWS.Socket , schema : MyAppWeb.Schema @impl Absinthe.GraphqlWS.Socket def handle_message ( { :internal_thing , id } , socket ) do { :ok , assign ( socket , :message , id ) } end def handle_message ( { :external_thing , _id } , socket ) do { :push , { :text , &quot;{}&quot; } , socket } end end","ref":"installation.html#optional-callbacks","title":"Installation - Optional callbacks","type":"extras"},{"doc":"AbsintheGraphqlWS Adds a websocket transport for the GraphQL over WebSocket Protocol to Absinthe running in Phoenix.","ref":"readme.html","title":"AbsintheGraphqlWS","type":"extras"},{"doc":"https://github.com/enisdenjo/graphql-ws This project is heavily inspired by subscriptions-transport-ws","ref":"readme.html#references","title":"AbsintheGraphqlWS - References","type":"extras"},{"doc":"Add absinthe_graphql_ws to your list of dependencies in mix.exs : def deps do [ { :absinthe_graphql_ws , github : &quot;geometerio/absinteh_graphql_ws&quot; } ] end","ref":"readme.html#installation","title":"AbsintheGraphqlWS - Installation","type":"extras"}]